#!/usr/bin/perl
#
#
# Copyright (c) 2012 Peter Varkoly <peter@varkoly.de> Nürnberg, Germany.  All rights reserved.
# Copyright (c) 2009 Peter Varkoly <peter@varkoly.de>, Fürth.  All rights reserved.
#
# $Id: oss-client-control.pl pv Exp $
#
#
=head1 NAME

 oss-client-control-server-daemon.pl
 
=head1 PREFACE

 Control daemon for OSS Clients on the server side.

=head1 DESCRIPTION

This daemon is waiting for messages from the Clients of the OSS.

Following commands are implemented at the time:

=item B<TurnOnCmd>

=item B<TurnOffCmd>

=cut

$| = 1; # do not buffer stdout

use strict;
use Getopt::Long;
use IO::Socket;
use IO::Socket::SSL;
use Data::Dumper;

$IO::Socket::SSL::DEBUG=1;

my $name = shift;

my $LocalPort = '1969';
my $LocalAddr = 'admin';
my ($client, $client_address);

#Global Variables
my %REPLY   = ();
my $CDATE   = undef;
my $COMMAND = undef;
my $TAG     = undef;
my $TEXT    = undef;
my $OS      = 'Linux';
my $LOGDIR  = "/var/log/";
my $DEBUG   = 0;
#parsing parameter
my $fhostname = `hostname -f`;
chomp $fhostname;
my( $hostname, $domainname ) = split/\./,$fhostname,2;

sub xml_time()
{
    my  $timezone = `/bin/date +%:z`; chomp $timezone;
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    return sprintf('%4d-%02d-%02dT%02d:%02d:%02d.000%s', $year+1900,$mon+1,$mday,$hour,$min,$sec,$timezone);
}

if( -e "/etc/salt/pki/master/minions/$name.$domainname" ) {
	die "Salt already installed.";
}
my $token = `cat /var/adm/oss/toke-$name`;
        my $command= '<?xml version="1.0" encoding="utf-8"?>
<ExecuteCommandCmd xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
<IsError>false</IsError>
<RequestDate>'.xml_time().'</RequestDate>
<Direction>REQ</Direction>
<CommandHandlerClass>Extis.Wcd.Commands.ExecuteCommandCmd, Extis.Wcd, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null</CommandHandlerClass>
<Token>'.$token.'</Token>
<ExecutableFileName>cmd.exe</ExecutableFileName>
<ExecutableWorkingDirectory>C:\\Windows\\System32</ExecutableWorkingDirectory>
<ExecutableArguments>/c wget http://admin/ClientSetup.exe &amp;&amp; ClientSetup.exe /i /Passive MinionName='.$name.'.'.$domainname.'</ExecutableArguments>
</ExecuteCommandCmd>';

sleep 5;
my $command_length = bytes::length $command;
my $p_size = pack ("l", $command_length);

my $PeerPort = 1969;
my $sock     = undef;
my $count      = 100;

while( ! $sock && $count )
{
	$sock = IO::Socket::SSL->new(
	    PeerAddr        => $name,
	    PeerPort        => $PeerPort,
	    Timeout         => 1,
	    Blocking        => 1,
	    SSL_version     => 'SSLv3',
	    SSL_verify_mode => SSL_VERIFY_NONE

	);
	last if ( $sock );
	$count--;
	print "Try $name $count\n";
	sleep 2;
}
if( $sock )
{
	#send the command
	my $command_length = bytes::length $command;
	my $p_size = pack ("l", $command_length);
	syswrite $sock, $p_size, 4;
	syswrite $sock, $command, $command_length;

	#read the command
	my $read   = 0;
	my $tmp    = "";
	my $answer = "";
	my $package_length = 4;

	while( $read = sysread( $sock , $tmp, $package_length ) )
	{
	    $package_length -= $read;
	    $answer .= $tmp;
	    $tmp    = '';
	    last if( !$package_length);
	}

	my $pl     = 16384;
	$package_length = unpack("l", $answer);
	if( $package_length < 16384 )
	{
	    $pl = $package_length;
	}
	$answer = "";
	while( $read = sysread( $sock , $tmp, $pl ) )
	{
	    $package_length -= $read;
	    if( $package_length < 16384 )
	    {
		    $pl = $package_length;
	    }
	    $answer .= $tmp;
	    $tmp = '';
	    last if( !$pl);
	}

	$sock->close;
	print "$answer\n";
	print "SUCCESS\n";
	exit 0;

}
else
{
	print "ERROR Can not connect the client $name ".xml_time()."\n";
	exit 1;
	#TODO WE NEED A MESSAGES TO LMD 
}


