#!/usr/bin/perl

use strict;

my $WORKGROUP = shift;
system("mkdir -p /home/archiv/migrate-to-4-0/accounts/");

open USERS,"</home/archiv/migrate-to-4-0/OSS-MIGRATE-TO-4-0-prepare.users";
while(<USERS>) {
	my ( $uid,$sn,$givenName,$unixHomeDirectory,$oldUidNumber,$uidNumber ) = split /:/;
	next if( lc($uid) eq "register" );
	if( lc($uid)  eq "administrator" ) {
		$unixHomeDirectory = "/home/sysadmins/administrator";
		$oldUidNumber      = 0;
	}
	my $DN=`/usr/bin/ldbsearch  -H /var/lib/samba/private/sam.ldb cn=$uid dn | grep dn: | grep Users `;
	print "Prozessing User $uid\n";
	chomp $DN; chomp $uidNumber;
	$givenName = $sn if( ! $givenName );
	my $LDIF="$DN
changetype: modify
add: uid
uid: $uid
-
add: uidNumber
uidNumber: $oldUidNumber
-
add: unixHomeDirectory
unixHomeDirectory: $unixHomeDirectory
-
add: gidNumber
gidNumber: 100
-
add: loginShell
loginShell: /bin/bash
-
add: msSFU30NisDomain
msSFU30NisDomain: $WORKGROUP
-
add: msSFU30Name
msSFU30Name: $uid
-
add: homeDirectory
homeDirectory: \\\\admin\\$uid
-
add: homeDrive
homeDrive: Z:
-
add: scriptPath
scriptPath: $uid.bat
-
add: profilePath
profilePath: \\\\admin\\profiles\\$uid
-
add: givenName
givenName: $givenName
-
add: sn
sn: $sn

";
	open USER,">/home/archiv/migrate-to-4-0/accounts/$uid.ldif";
	print USER $LDIF;
	close USER;
	`/usr/bin/ldbmodify -H /var/lib/samba/private/sam.ldb /home/archiv/migrate-to-4-0/accounts/$uid.ldif`;
	system("ln -s $unixHomeDirectory /home/$WORKGROUP/$uid");
}

open GROUPS,"</home/archiv/migrate-to-4-0/OSS-MIGRATE-TO-4-0-prepare.groups";
while(<GROUPS>) {
	my ( $cn,$oldGidNumber,$gidNumber ) = split /:/;
	my $DN=`/usr/bin/ldbsearch  -H /var/lib/samba/private/sam.ldb cn=$cn dn | grep dn: | grep Users `;
	print "Prozessing Group $cn\n";
	chomp $DN; chomp $gidNumber;
	my $LDIF = "$DN
changeType: modify
add: gidNumber
gidNumber: $oldGidNumber
-
add: msSFU30NisDomain
msSFU30NisDomain: $WORKGROUP
-
add: msSFU30Name
msSFU30Name: $cn
";
	open GROUP,">/home/archiv/migrate-to-4-0/accounts/$cn.ldif";
	print GROUP $LDIF;
	close GROUP;
	`/usr/bin/ldbmodify -H /var/lib/samba/private/sam.ldb /home/archiv/migrate-to-4-0/accounts/$cn.ldif`;
}
