#!/bin/bash
echo
echo "Vorbereitung der Migration von OSS 3-4-2 auf OSS-4-0"
echo
echo "Bitte beachten Sie für die Migration: auch wenn der Prozeß sorgfältig getestet wurde, können wir keine Garantie für die Übernahme aller Daten übernehmen. Der Migrations-Prozeß kann nur Daten übernehmen, die von einem richtig gepflegten und aktualisierten OSS 3 stammen. Daten von installierter Fremdsoftware oder OSS Daten, die von Fremdsoftware angepaßt und angereichert wurden, können ggf. nicht korrekt übernommen werden. Wenn Sie in Ihrem OSS Fremdsoftware installiert haben, dann wird diese aller Voraussicht nach deinstalliert oder wird nicht mehr korrekt funktionieren. Aus Umstellung zur Active-Directory Server Kompatibilität und der daraus resultierenden Notwendigkeit der Eindeutigkeit von Objekt-Namen ergibt sich die Besonderheit, dass bei Benutzer, Gruppen und Workstation-Accounts mit identischen Namen nur das Benutzerkonto migriert wird. Die Daten der Gruppe bleiben dann zwar erhalten, die Gruppe selbst wird jedoch nicht migriert.
Drucker können nur dann übernommen werden, wenn dieser sowohl über die Adminoberfläche als auch in CUPS mit völlig identischen namen angelegt wurden. Damit solche Drucker in OSS-4-0 weiter verwaltet werden können, muss für die Geräte die Gerätekonfiguration nach der Migration über die Adminoberfläche auf 'Printer' gesetzt werden. Drucker die diese Schema nicht entsprechen, müssen vor der Migration gelöscht und neu angelegt werden."
echo
echo
echo "Wollen Sie mit der Migration fortfahren? j/n"
read a
if [ "$a" != "j" ]; then
    exit 1
fi

echo
echo "Bitte aktuelle Systemzeit überprüfen!"
date
echo "Soll die Zeit mit pool.ntp.org synchronisiert werden? j/n"
read sync
if [ "$sync" = "j" ]; then
   sntp -P no -r pool.ntp.org
   hwclock   --systohc
fi

/usr/share/oss/tools/reset_password_age.pl

/usr/share/oss/oss-migration-3-to-4/oss-prepare-migration.pl 2>&1 | tee /var/log/OSS-Migrate-4-0.log
wget -O /srv/www/admin/ClientSetup.exe http://repo.openschoolserver.net/downloads/OSS40/ClientSetup.exe

